﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Diagnostics;

namespace XamComboBox
{
    public class Model
    {

        private string handle;

        public Model(string handle)
        {
            this.handle = handle;
        }
        
        public string answer
        {
            get;
            set;
        }

        OptionInstance[] options = new OptionInstance[] 
        {
            new OptionInstance("Yes", "true"),
            new OptionInstance("No", "false")
        };

        public OptionInstance[] Options
        {
            get { return this.options; }
        }

        public OptionInstance CurrentOption
        {
            get
            {
                Debug.WriteLine(String.Format("Getter: {0} :: {1}", this.handle, DateTime.Now));

                foreach (OptionInstance option in this.options)
                {
                    if (option.Value == answer)
                        return option;
                }

                this.answer = this.options[0].Value;

                return this.options[0];
            }
            set
            {

                Debug.WriteLine(String.Format("Setter: {0} :: {1}", this.handle, DateTime.Now));

                if (value != null && this.answer != value.Value)
                {
                    this.answer = value.Value;
                }
            }

        }
    }

    public class OptionInstance
    {
        public OptionInstance(string caption, string value)
        {
            this.Caption = caption;
            this.Value = value;
        }

        public string Caption
        {
            get;
            set;
        }

        public string Value
        {
            get;
            set;
        }
    }
}
